<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body" id="cardBody">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
    <div id="videoBoxBackGround" style="position: fixed;z-index: 1000;top: 0;left: 0;width: 100%;height: 100%;background-color: rgba(0,0,0,0.6); display: none;">
        <div role="button" class="viewer-button viewer-close video-close-btn"></div>
        <div id="videoBox" style="width: 600px; height: 400px; position: absolute; left: 50%; top: 50%; margin-left: -300px; margin-top: -200px;">
            <div id="video" style="width: 100%; height: 100%"></div>
        </div>
    </div>
</div>
<script src="assets/js/vendor/ckplayer/ckplayer/ckplayer.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script type="text/javascript">
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;
        var tableUrl = 'api/file/listpagefileinfo';
        var viewer = new Viewer(document.getElementById('cardBody'), {navbar: true});;
        var viewerTimeout;
        var imageTypeArray = ['png','jpg','jpeg','gif','blob'];
        var imageIdArray = [];
        var ckPlayerFileId;
        var ckPlayer = new ckplayer({
            container: '#video',
            variable: 'player',
            flashplayer: false,
            video: {
                file: '',
                type: 'video/mp4'
            },
        });
        // 是图片类型
        function isImageType(type) {
            for(var i = 0, item; item = imageTypeArray[i++];) {
                if(item === type) {
                    return true;
                }
            }
            return false;
        }

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'fileId', width: 300, title: 'ID', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileName', width: 400, title: '文件名称', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                var icon = '<i class="fa fa-download"></i>';
                                var result = '';
                                if(isImageType(row.fileType)) {
                                    result += '<img src="route/file/downloadfile/true/'+ row.fileId +'" style="display: none;"/>';
                                    imageIdArray.push(row.fileId);
                                    icon = '<i class="fa fa-image"></i>';
                                } else if(row.fileType === 'mp4') {
                                    icon = '<i class="fa fa-video-camera"></i>';
                                }
                                result += '<button class="layui-btn layui-btn-xs layui-btn-normal" lay-event="searchFileEvent"> '+ icon +' '+ rowData +'</button>'
                                if(viewerTimeout) {
                                    clearTimeout(viewerTimeout);
                                }
                                viewerTimeout = setTimeout(function() {
                                    viewer.update();
                                }, 1000);
                                return result;
                            }
                        },
                        {field: 'fileUrl', width: 500, title: '相对位置', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileType', width: 100, title: '文件类型', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileSize', width: 120, title: '文件大小', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileSummary', width: 350, title: '文件描述', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'isSourceFile', width: 100, title: '保存类型', align:'center',
                            templet: function(row) {
                                if(!row.fileSummary) {
                                    return '无';
                                }
                                if(row.fileSummary.indexOf('MD5:') == 0) {
                                    return '源文件';
                                }
                                if(row.fileSummary.indexOf('REF:') == 0) {
                                    return '引用';
                                }
                                return '错误';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    imageIdArray.splice(0, imageIdArray.length);
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeFile(isRemoveSource, ids) {
            var layIndex;
            top.restAjax.delete(top.restAjax.path('api/file/removefile/{isRemoveSource}/{ids}', [isRemoveSource, ids]), {}, null, function (code, data) {
                top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                reloadTable();
            }, function (code, data) {
                top.dialog.msg(data.msg);
            }, function () {
                layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
            }, function () {
                top.dialog.close(layIndex);
            });
        }
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, '同时删除文件(不可逆)', top.dataMessage.button.no],
                shade: 0.3,
                btn1: function (index) {
                    top.dialog.close(index);
                    removeFile(0, ids);
                },
                btn2: function(index) {
                    top.dialog.close(index);
                    removeFile(1, ids);
                },
                btn3: function(index) {
                    top.dialog.close(index);
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item['fileId'];
                    }
                    removeData(ids);
                }
            }
        });
        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var event = obj.event;
            if(event === 'searchFileEvent') {
                if(isImageType(data.fileType)) {
                    for(var i = 0; i < imageIdArray.length; i++) {
                        if(data.fileId === imageIdArray[i]) {
                            viewer.view(i);
                            break;
                        }
                    }
                } else if(data.fileType === 'mp4') {
                    $('#videoBoxBackGround').show();
                    if(ckPlayerFileId == data.fileId) {
                        return;
                    }
                    ckPlayer.newVideo({
                        video: 'route/file/downloadfile/true/'+ data.fileId
                    });
                    ckPlayerFileId = data.fileId;
                }
            }
        });
        $('.video-close-btn').on('click', function() {
            ckPlayer.videoPause();
            $('#videoBoxBackGround').hide();
        })
    });
</script>
</body>
</html>